package com.adamatomic.Mode
{
	import adobe.utils.CustomActions;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.system.System;
	import flash.text.engine.BreakOpportunity;
	import flash.ui.Mouse;
	import org.flixel.*;

	public class MenuState extends FlxState
	{						
		public var sprites:Array;
		public var names:Array;
		public var player:FlxSprite;
		public var descriptiontext:FlxText;
		public var descriptiontext2:FlxText;
		public var descriptiontext3:FlxText;
		
		public var spriteNames:Array = [
["Allah", "The Greatest Name"],	//1
["Ar-Rahman", "The All-Compassionate"], //2
["Ar-Rahim", "The All-Merciful"], //3
["Al-Malik", "The Absolute Ruler"], //4
["Al-Quddus", "The Holy"], //5
["As-Salam", "The Source of Peace"], //6
["Al-Mumin", "The Inspirer of Faith"], //7
["Al-Muhaymin", "The Guardian"], //8
["Al-Aziz", "The Victorious"], //9
["Al-Jabbar", "The Compeller"], //10
["Al-Mutakabbir", "The Greatest"], //11
["Al-Khaliq","The Creator"], //12
["Al-Bari","The Maker of Order"], //13
["Al-Musawwir","The Shaper of Beauty"], //14
["Al-Ghaffar","The Forgiving"], //15
["Al-Qahhar","The Subduer"], //16
["Al-Wahhab","The Giver of All"],//17
["Ar-Razzaq","The Sustainer"],//18
["Al-Fattah","The Opener"],//19
["Al-Alim","The Knower of All"],//20
["Al-Qabid","The Constrictor"],//21
["Al-Basit","The Reliever"],//22
["Al-Khafid","The Abaser"],//23
["Ar-Rafi","The Exalter"],//24
["Al-Muizz","The Bestower of Honors"],//25
["Al-Mudhill","The Humiliator"],//26
["As-Sami","The Hearer of All"],//27
["Al-Basir","The Seer of All"],//28
["Al-Hakam","The Judge"],//29
["Al-'Adl","The Just"],//30
["Al-Latif","The Subtle One; The Inexpressible, Unfathomable"],//31
["Al-Khabir","The All-Aware"],//32
["Al-Halim","The Forebearing"],//33
["Al-Azim","The Magnificent"],//34
["Al-Ghafur","The Forgiver and Hider of Faults"],//35
["Ash-Shakur","The Rewarder of Thankfulness"],//36
["Al-'Ali","The Highest"],//37
["Al-Kabir","The Greatest"],//38
["Al-Hafiz","The Preserver"],//39
["Al-Muqit","The Nourisher"],//40
["Al-Hasib","The Accounter"],//41
["Al-Jalil","The Mighty"],//42
["Al-Karim","The Generous"],//43
["Ar-Raqib","The Watchful One"],//44
["Al-Mujib","The Responder to Prayer"],//45
["Al-Wasi","The All-Comprehending"],//46
["Al-Hakim","The Perfectly Wise"],//47
["Al-Wadud","The Loving One"],//48
["Al-Májid","The Majestic One"],//49
["Al-Ba'ith","The Resurrector"],//50
["Ash-Shahid","The Witness"],//51
["Al-h Haqq","The Truth"],//52
["Al-Wakil","The Trustee"],//53
["Al-Qawi","The Possessor of All Strength"],//54
["Al-Matin","The Forceful One"],//55
["Al-Wáli","The Governor"],//56
["Al-Hamid","The Praised One"],//57
["Al-Muhsi","The Appraiser"],//58
["Al-Mubdi","The Originator"],//59
["Al-Mu'id","The Restorer"],//60
["Al-Muhyi","The Giver of Life"],//61
["Al-Mumit","The Taker of Life"],//62
["Al-Hayy","The Ever Living One"],//63
["Al-Qayyum","The Self-Existing One"],//64
["Al-Wajid","The Finder"],//65
["Al-Majíd","The Glorious"],//66
["Al-Wahid","The Only One"],//67
["Al-Ahad","The One"],//68
["As-Samad","The Eternal"],//69
["Al-Qadir","The All Powerful"],//70
["Al-Muqtadir","The Creator of All Power"],//71
["Al-Muqaddim","The Expediter"],//72
["Al-Mu'akhkhir","The Delayer"],//73
["Al-Awwal","The First"],//74
["Al-Akhir","The Last"],//75
["Az-Zahir","The Manifest One"],//76
["Al-Batin","The Hidden One"],//77
["Al-Walí","The Protecting Friend"],//78
["Al-Muta'ali","The Supreme One"],//79
["Al-Barr","The Doer of Good"],//80
["At-Tawwib","The Guide to Repentance"],//81
["Al-Muntaqim","The Avenger"],//82
["Al-Afu","The Forgiver"],//83
["Ar-Ra'uf","The Clement"],//84
["Al-Malik al-Mulk","The Owner of All"],//85
["Dhul-Jalali Wal-Ikram","The Lord of Majesty and Bounty"],//86
["Al-Muqsit","The Equitable One"],//87
["Al-Jami","The Gatherer"],//88
["Al-Ghani","The Rich One"],//89
["Al-Mughni","The Enricher"],//90
["Al-Mani","The Preventer of Harm"],//91
["Ad-Darr","The Creator of the Harmful"],//92
["An-Nafi","The Creator of Good"],//93
["An-Nur","The Light"],//94
["Al-Hadi","The Guide"],//95
["Al-Badi","The Originator"],//96
["Al-Baqi","The Everlasting One"],//97
["Al-Warith","The Inheritor of All"],//98
["Ar-Rashid","The Righteous Teacher"],//99
["As-Sabur","The Patient One"]//100

];
		override public function create():void
		{
			names = new Array();
			sprites = new Array();
			sprites.push(TitleState.img1);
			sprites.push(TitleState.img2);
			sprites.push(TitleState.img3);
			sprites.push(TitleState.img4);
			sprites.push(TitleState.img5);
			sprites.push(TitleState.img6);
			sprites.push(TitleState.img7);
			sprites.push(TitleState.img8);
			sprites.push(TitleState.img9);
			sprites.push(TitleState.img10);
			sprites.push(TitleState.img11);
			sprites.push(TitleState.img12);
			sprites.push(TitleState.img13);
			sprites.push(TitleState.img14);
			sprites.push(TitleState.img15);
			sprites.push(TitleState.img16);
			sprites.push(TitleState.img17);
			sprites.push(TitleState.img18);
			sprites.push(TitleState.img19);
			sprites.push(TitleState.img20);
			sprites.push(TitleState.img21);
			sprites.push(TitleState.img22);
			sprites.push(TitleState.img23);
			sprites.push(TitleState.img24);
			sprites.push(TitleState.img25);
			sprites.push(TitleState.img26);
			sprites.push(TitleState.img27);
			sprites.push(TitleState.img28);
			sprites.push(TitleState.img29);
			sprites.push(TitleState.img30);
			sprites.push(TitleState.img31);
			sprites.push(TitleState.img32);
			sprites.push(TitleState.img33);
			sprites.push(TitleState.img34);
			sprites.push(TitleState.img35);
			sprites.push(TitleState.img36);
			sprites.push(TitleState.img37);
			sprites.push(TitleState.img38);
			sprites.push(TitleState.img39);
			sprites.push(TitleState.img40);
			sprites.push(TitleState.img41);
			sprites.push(TitleState.img42);
			sprites.push(TitleState.img43);
			sprites.push(TitleState.img44);
			sprites.push(TitleState.img45);
			sprites.push(TitleState.img46);
			sprites.push(TitleState.img47);
			sprites.push(TitleState.img48);
			sprites.push(TitleState.img49);
			sprites.push(TitleState.img50);
			sprites.push(TitleState.img51);
			sprites.push(TitleState.img52);
			sprites.push(TitleState.img53);
			sprites.push(TitleState.img54);
			sprites.push(TitleState.img55);
			sprites.push(TitleState.img56);
			sprites.push(TitleState.img57);
			sprites.push(TitleState.img58);
			sprites.push(TitleState.img59);
			sprites.push(TitleState.img60);
			sprites.push(TitleState.img61);
			sprites.push(TitleState.img62);
			sprites.push(TitleState.img63);
			sprites.push(TitleState.img64);
			sprites.push(TitleState.img65);
			sprites.push(TitleState.img66);
			sprites.push(TitleState.img67);
			sprites.push(TitleState.img68);
			sprites.push(TitleState.img69);
			sprites.push(TitleState.img70);
			sprites.push(TitleState.img71);
			sprites.push(TitleState.img72);
			sprites.push(TitleState.img73);
			sprites.push(TitleState.img74);
			sprites.push(TitleState.img75);
			sprites.push(TitleState.img76);
			sprites.push(TitleState.img77);
			sprites.push(TitleState.img78);
			sprites.push(TitleState.img79);
			sprites.push(TitleState.img80);
			sprites.push(TitleState.img81);
			sprites.push(TitleState.img82);
			sprites.push(TitleState.img83);
			sprites.push(TitleState.img84);
			sprites.push(TitleState.img85);
			sprites.push(TitleState.img86);
			sprites.push(TitleState.img87);
			sprites.push(TitleState.img88);
			sprites.push(TitleState.img89);
			sprites.push(TitleState.img90);
			sprites.push(TitleState.img91);
			sprites.push(TitleState.img92);
			sprites.push(TitleState.img93);
			sprites.push(TitleState.img94);
			sprites.push(TitleState.img95);
			sprites.push(TitleState.img96);
			sprites.push(TitleState.img97);
			sprites.push(TitleState.img98);
			sprites.push(TitleState.img99);
			sprites.push(TitleState.img100);
			
			for (var i:int = 0; i < sprites.length; i++)
			{
				var px:int = (i/10) * 300;
				var py:int = (i % 10) * 300;
				var spr:FlxSprite = new FlxSprite(px, py, sprites[i]);
				spr.moves = false;
				names.push(spr);
				this.add(spr);				
			}
			
			player = new FlxSprite(0, 0);
			player.createGraphic(20, 20, 0xff000000);
			player.x = 5 * 300 + 110;
			player.y = 5 * 300 + 220;
			this.add(player);
			
			
			descriptiontext = new FlxText(0, 400, 640, "BOOP BOOP");
			//descriptiontext.color = 0x44ff0000;
			//descriptiontext.shadow = 2;
			descriptiontext.color = 0x000000;
			descriptiontext.alignment = 'center';
			descriptiontext.size = 32;
			this.add(descriptiontext);
			descriptiontext2 = new FlxText(0, 400, 640, "BOOP BOOP");
			//descriptiontext2.shadow = 2;
			descriptiontext2.color = 0x000000;
			descriptiontext2.alignment = 'center';
			descriptiontext2.size = 16;
			this.add(descriptiontext2);
			descriptiontext3 = new FlxText(0, 400, 640, "(press x)");
			//descriptiontext2.shadow = 2;
			descriptiontext3.color = 0x000000;
			descriptiontext3.alignment = 'center';
			descriptiontext3.size = 16;
			this.add(descriptiontext3);

			FlxG.follow(player);
		}
		
		override public function update():void
		{			
			super.update();
			
			const speed:Number = 80;
			
			if (FlxG.keys.pressed('UP'))
			{
				player.y=player.y-FlxG.elapsed*speed;
			}

			
			if (FlxG.keys.pressed('DOWN'))
			{
				player.y=player.y+FlxG.elapsed*speed;
			}
			
			if (FlxG.keys.pressed('LEFT'))
			{
				player.x=player.x-FlxG.elapsed*speed;
			}
			if (FlxG.keys.pressed('RIGHT'))
			{
				player.x=player.x+FlxG.elapsed*speed;
			}

			descriptiontext.visible = false;
			descriptiontext2.visible = false;
			descriptiontext3.visible = false;
			
			for (var i:int = 0; i < sprites.length; i++)
			{
				var spr:FlxSprite = names[i];
				if (spr.overlaps(player))
				{
			
					descriptiontext.x = -FlxG.scroll.x;
					descriptiontext.y = -FlxG.scroll.y+ 350;
					descriptiontext2.x = -FlxG.scroll.x;
					descriptiontext2.y = -FlxG.scroll.y + 400;	
					descriptiontext.text = spriteNames[i][0];
					descriptiontext2.text = spriteNames[i][1];
					descriptiontext3.x = -FlxG.scroll.x;
					descriptiontext3.y = -FlxG.scroll.y + 450;	
					
					descriptiontext.visible = true;
					descriptiontext2.visible = true;
					descriptiontext3.visible = true;
					
					if (spr.alpha>0.8 && FlxG.keys.justPressed('X'))
					{
						spr.alpha = 0.5;
						FlxG.play(TitleState.sndBlip);
					}
					
					break;
				}
			}
		}
		
	}
}

